<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.operator.compose;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import ch.javasoft.math.array.ArrayOperations;<a name="line.36"></a>
<FONT color="green">037</FONT>    import ch.javasoft.math.operator.AbstractBinaryOperator;<a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.math.operator.BinaryOperator;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.math.operator.NullaryOperator;<a name="line.39"></a>
<FONT color="green">040</FONT>    <a name="line.40"></a>
<FONT color="green">041</FONT>    /**<a name="line.41"></a>
<FONT color="green">042</FONT>     * The &lt;code&gt;NullaryBinaryOperator&lt;/code&gt; applies a {@link BinaryOperator} <a name="line.42"></a>
<FONT color="green">043</FONT>     * &amp;oplus; to the result of a nested {@link NullaryOperator} and <a name="line.43"></a>
<FONT color="green">044</FONT>     * {@link BinaryOperator} instance. It is thus itself a binary operator:<a name="line.44"></a>
<FONT color="green">045</FONT>     * &lt;pre&gt;<a name="line.45"></a>
<FONT color="green">046</FONT>     *   this.operate(x1, x2) = ( operand1.operate() &amp;oplus; operand2.operate(x1, x2) )<a name="line.46"></a>
<FONT color="green">047</FONT>     * &lt;/pre&gt;<a name="line.47"></a>
<FONT color="green">048</FONT>     * <a name="line.48"></a>
<FONT color="green">049</FONT>     * @type T      result type of the operation<a name="line.49"></a>
<FONT color="green">050</FONT>     * @type A      array type of result<a name="line.50"></a>
<FONT color="green">051</FONT>     */<a name="line.51"></a>
<FONT color="green">052</FONT>    public class NullaryBinaryOperator&lt;T extends Number, A&gt; extends AbstractBinaryOperator&lt;T, A&gt; {<a name="line.52"></a>
<FONT color="green">053</FONT>    <a name="line.53"></a>
<FONT color="green">054</FONT>            private final BinaryOperator&lt;T, A&gt;        operator;<a name="line.54"></a>
<FONT color="green">055</FONT>            private final NullaryOperator&lt;T, A&gt; operand1;<a name="line.55"></a>
<FONT color="green">056</FONT>            private final BinaryOperator&lt;T, A&gt;        operand2;<a name="line.56"></a>
<FONT color="green">057</FONT>            private final TempArray&lt;A&gt;                        temp;<a name="line.57"></a>
<FONT color="green">058</FONT>            <a name="line.58"></a>
<FONT color="green">059</FONT>            public NullaryBinaryOperator(ArrayOperations&lt;A&gt; ops, BinaryOperator&lt;T, A&gt; operator, NullaryOperator&lt;T, A&gt; operand1, BinaryOperator&lt;T, A&gt; operand2) {<a name="line.59"></a>
<FONT color="green">060</FONT>                    this.operator   = operator;<a name="line.60"></a>
<FONT color="green">061</FONT>                    this.operand1   = operand1;<a name="line.61"></a>
<FONT color="green">062</FONT>                    this.operand2   = operand2;<a name="line.62"></a>
<FONT color="green">063</FONT>                    this.temp               = new TempArray&lt;A&gt;(ops, 2);<a name="line.63"></a>
<FONT color="green">064</FONT>            }<a name="line.64"></a>
<FONT color="green">065</FONT>            public T operate(T operand1, T operand2) {<a name="line.65"></a>
<FONT color="green">066</FONT>                    final T operated1 = this.operand1.operate();<a name="line.66"></a>
<FONT color="green">067</FONT>                    final T operated2 = this.operand2.operate(operand1, operand2);<a name="line.67"></a>
<FONT color="green">068</FONT>                    return operator.operate(operated1, operated2);<a name="line.68"></a>
<FONT color="green">069</FONT>            }<a name="line.69"></a>
<FONT color="green">070</FONT>            public void operate(A operand1, int index1, A operand2, int index2, A dst, int dstIndex) {<a name="line.70"></a>
<FONT color="green">071</FONT>                    final A tmp = temp.get();<a name="line.71"></a>
<FONT color="green">072</FONT>                    this.operand1.operate(tmp, 0);<a name="line.72"></a>
<FONT color="green">073</FONT>                    this.operand2.operate(operand1, index1, operand2, index2, tmp, 1);<a name="line.73"></a>
<FONT color="green">074</FONT>                    this.operator.operate(tmp, 0, tmp, 1, dst, dstIndex);<a name="line.74"></a>
<FONT color="green">075</FONT>            }<a name="line.75"></a>
<FONT color="green">076</FONT>    }<a name="line.76"></a>




























































</PRE>
</BODY>
</HTML>
